﻿using System;
using System.Collections.Generic;
using System.Text;
using fit;
using fitlibrary;
namespace info.fitnesse
{

//START:linkinsert
    public class LinkInsertFixture : ColumnFixture
    {
        private ILinkRepository repo;
        Link l;
        public LinkInsertFixture(ILinkRepository repo)
        {
            this.repo = repo;
        }
        public int Id 
        { 
           get 
           { 
              return repo.Save(l); 
           } 
        }
        public override void Reset()
        {
            l = new Link(); SetSystemUnderTest(l); 
        }

    }
//END:linkinsert
//START:linkcheck
    public class LinkCheckFixture : ColumnFixture
    {
        private ILinkRepository repo;
        public LinkCheckFixture(ILinkRepository repo)
        {
            this.repo = repo;
        }
        public int Id 
        { 
           set 
           { 
              SetSystemUnderTest(repo.FindById(value));
           } 
        }
    }
//END:linkcheck
    public class AlternatingSUT : DoFixture
    {
        private ILinkRepository repo = new MemoryLinkRepository();
        public Fixture DefineLinks()
        {
            return new LinkInsertFixture(repo);
        }
        public Fixture CheckLinks()
        {
            return new LinkCheckFixture(repo);
        }
    }
}
