﻿using System;
using System.Collections.Generic;
using System.Text;

namespace info.fitnesse
{
//START:link
    public class Link
    {
        public Link()
        {
        }
        public Link(String name, String url)
        {
            this.Name = name;
            this.Url = url;
        }
        public int Id { get; set; }
        public String Name { get; set; }
        public String Url { get; set; }
        public Boolean Valid
        {
            get
            {
                return
                        ((!String.IsNullOrEmpty(Name)) &&
                        (!String.IsNullOrEmpty(Url)) &&
                        Url.Contains("://"));
            }
        }
    }
//END:link
//START:ilinkrepository
    public interface ILinkRepository
    {
         Link FindById(int id);
         IEnumerable<Link> FindAll();
         int Save(Link l);
        
    }
//END:ilinkrepository
//START:memorylinkrepository
    public class MemoryLinkRepository : ILinkRepository
    {
        private List<Link> links=new List<Link>();
        public Link FindById(int id)
        {
            return links[id];
        }
        public IEnumerable<Link> FindAll()
        {
            return links;
        }

      
        public int Save(Link l)
        {
            int nextIndex = links.Count;
            links.Add(l);
            return nextIndex;
        }
    }
//END:memorylinkrepository
}
