﻿using System;
using System.Collections.Generic;
using fit;
using fitlibrary;
namespace info.fitnesse
{
    public class LinkSetupFixture : SetUpFixture
    {
        private ILinkRepository repo;
        public LinkSetupFixture(ILinkRepository repo)
        {
            this.repo = repo;
        }
        public void NameUrl(String name, String url)
        {
            repo.Save(new Link { Url = url, Name = name });
        }
    }
    public class FlowCollections: DoFixture
    {
        private ILinkRepository repo = new MemoryLinkRepository();
        public Fixture DefineLinks()
        {
            return new LinkSetupFixture(repo);
        }
        public IEnumerable<Link> ListLinks()
        {
            return repo.FindAll();
        }
    }
#START:flowsut    
    public class FlowSystemUnderTest : DoFixture
    {
        private ILinkRepository repo = new MemoryLinkRepository();
        public Fixture DefineLinks()
        {
            return new LinkSetupFixture(repo);
        }
        public FlowSystemUnderTest()
        {
            SetSystemUnderTest(repo);
        }
    }
#START:flowsut    
#START:withsut    
    public class WithSystemUnderTest : DoFixture
    {
        public Fixture DefineLinks()
        {
            return new LinkSetupFixture((ILinkRepository) this.mySystemUnderTest);
        }
    }
#END:withsut    
}
